Bug 386341 - Review Request: fxload - A helper program to download firmware into FX and FX2 EZ-USB devices
Review Request: fxload - A helper program to download firmware into FX and FX...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Jason Tibbitts
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-11-16 00:49 EST by Stephen Warren
Modified: 2008-02-09 14:42 EST (History)
4 users (show)

See Also:
Fixed In Version: 2002_04_11-6.fc7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-28 20:37:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tibbs: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Stephen Warren 2007-11-16 00:49:10 EST
Spec URL: http://www.wwwdotorg.org/downloads/fxload/fxload.spec
SRPM URL: http://www.wwwdotorg.org/downloads/fxload/fxload-2002_04_11-3.fc8.src.rpm
Description:
This program is conveniently able to download firmware into FX and FX2
EZ-USB devices, as well as the original AnchorChips EZ-USB.  It is
intended to be invoked by udev scripts when the unprogrammed device
appears on the bus.
Comment 1 Stephen Warren 2007-11-16 01:22:12 EST
Note: I based my work on the that in bug 188478 and bug 218887. I guess both
those got closed out due to lack of follow-through. I did make a couple changes
to the RPM for this review request; see the change log.
Comment 2 Jason Tibbitts 2007-11-16 13:20:02 EST
Note the following from a3load.hex:

# Cypress Semiconductor Corporation hereby grants a copyright license to
# use or redistribute this firmware image, in text or binary form as
# required, only in conjunction with devices using a Cypress USB
# microcontroller.  Every copy in any form of the firmware shall include
# Cypress copyright legends.

Now, it's not included in the final package, so that's OK.  But according to
this license, we can't even distribute the SRPM with it included, and you're
violating the license just by putting it on your web site.

This means that you have to actually strip the file from the tarball that you
package in the SRPM.  Include in your spec a comment on where the original
tarball comes from and some instructions on generating the stripped tarball from it.

Also, you need to specify the GPL version as detained in
http://fedoraproject.org/wiki/Licensing.  I believe this package is "GPL version
2 or later" so the License: tag should contain "GPLv2+".

Otherwise I think this package is fine.
Comment 3 Stephen Warren 2007-11-16 18:16:46 EST
Re comment 2: Yes, you're correct, I really shouldn't distribute it either as it
appears to stand.

However, I was searching around for information on whether a different version
existed with a better license, and found this:

http://marc.info/?l=linux-hotplug-devel&m=112957485713095&w=4

The referenced CVS browse URL has been moved to:
http://linux-hotplug.cvs.sourceforge.net/linux-hotplug/fxload/a3load.hex?revision=1.1&view=markup

Here, Greg K-H is claiming that with this license, it's fine to distribute it.
I'm not quite sure how he comes to that opinion. Perhaps it's because the hex
file is being distributed with SW that's specifically to drive a USB-FX device?
Who could resolve this question?
Comment 4 Jason Tibbitts 2007-11-16 19:42:14 EST
Here's the relevant statement:

   16 # Cypress Semiconductor Corporation hereby grants a copyright license to
   17 # use or redistribute this firmware image, in text or binary form as
   18 # required, only in conjunction with devices using a Cypress USB
   19 # microcontroller.  Every copy in any form of the firmware shall include
   20 # Cypress copyright legends.

Frankly I don't think this gives us any right at all to distribute the
a3load.hex file, since there is essentially no chance that the file will be
distributed with a Cypress USB microcontroller.  However, I'm not a lawyer, and
there may be finer meanings of "in conjunction with" that I'm not familiar with.  

Blocking FE-Legal to get a final ruling.  But note that there's no question that
this package with the a3load.hex stripped out of the source tarball (so that
it's not present in the SRPM) is OK for Fedora.
Comment 5 Stephen Warren 2007-11-17 01:22:18 EST
I have updated the package to remove a3load completely, and a couple other
cleanups. Latest versions:

Spec URL: http://www.wwwdotorg.org/downloads/fxload/fxload.spec
SRPM URL: http://www.wwwdotorg.org/downloads/fxload/fxload-2002_04_11-4.fc8.src.rpm
Comment 6 Tom "spot" Callaway 2007-11-17 10:53:17 EST
I'm not aware of any finer meaning of in conjunction with. While I do not think
it was Cypress's intent for this to be a distribution restriction (instead of
just a use restriction), the wording is poorly formulated.

a3load is not permissable for Fedora, unless someone from Cypress Semiconductor
Corp. clarifies the intent (or even better, rewords the license).
Comment 7 Stephen Warren 2007-11-17 12:44:25 EST
OK. Version 4 of the package in comment 5 above completely removes a3load.hex.

The package is certainly still useful without this file; only certain HW needs
the 2nd stage loader (don't know which). The Xilinx Spartan 3E starter board's
USB programmer, which I'm using with this S/W, certainly doesn't need a3load.

I guess we should start out packaging/distributing the SW without a3load, and
I'll see if I can get Cypress to clarify/reword the license, so we can include
a3load in a future revision.

As such, removing FE-legal blocking; hope that's OK.
Comment 8 Tom "spot" Callaway 2007-11-17 16:34:24 EST
Nope, thats fine. Just let me know if Cypress changes the license.
Comment 9 Stephen Warren 2007-11-17 16:45:41 EST
I have updated the package after more thoroughly reviewing the packaging
guidelines in the Wiki.

Spec URL: http://www.wwwdotorg.org/downloads/fxload/fxload.spec
SRPM URL: http://www.wwwdotorg.org/downloads/fxload/fxload-2002_04_11-5.fc8.src.rpm
Comment 10 Jason Tibbitts 2007-11-17 19:31:30 EST
I just saw a sponsorship request cross the line.  Was I supposed to take care of
that?  Nothing in this ticket indicates that you need sponsorship.
Comment 11 Stephen Warren 2007-11-17 19:40:30 EST
I do need sponsorship.

If you can sponsor me, that would be great. If you're unable, I do know somebody
else that probably can.

Thanks in anticipation.
Comment 12 Jason Tibbitts 2007-11-17 20:35:18 EST
* source files match upstream (generated according to instructions in the spec 
   and compared manually).
* package meets naming and versioning guidelines.
* specfile is properly named, is cleanly written and uses macros consistently.
* summary is OK.
* description is OK.
* dist tag is present.
* build root is OK.
* license field matches the actual license.
* license is open source-compatible.
* license text included in package.
* latest version is being packaged.
* BuildRequires are proper.
* compiler flags are appropriate.
* %clean is present.
* package builds in mock (rawhide, x86_64).
* package installs properly
* debuginfo package looks complete.
* rpmlint is silent.
* final provides and requires are sane:
   fxload = 2002_04_11-5.fc9
  =
   udev
* %check is not present; no test suite ustream.  I haven't the hardware to test 
   this with.
* no shared libraries are added to the regular linker search paths.
* owns the directory it creates.
* doesn't own any directories it shouldn't.
* no duplicates in %files.
* file permissions are appropriate.
* no scriptlets present.
* code, not content.
* documentation is small, so no -docs subpackage is necessary.
* %docs are not necessary for the proper functioning of the package.
* no headers.
* no pkgconfig files.
* no static libraries.
* no libtool .la files.

APPROVED
Comment 13 Stephen Warren 2007-11-17 21:41:21 EST
New Package CVS Request
=======================
Package Name: fxload
Short Description: A helper program to download firmware into FX and FX2 EZ-USB
devices
Owners: swarren
Branches: F-8
InitialCC: 
Cvsextras Commits: yes
Comment 14 Kevin Fenzi 2007-11-17 21:49:37 EST
cvs done.
Comment 15 Nicolas Chauvet (kwizart) 2007-11-18 07:24:54 EST
If this package is still usefull for go7007 I would appreciate to have it also
for F-7 branch. If possible...thx
Comment 16 Stephen Warren 2007-11-18 14:08:41 EST
The package builds fine under mock for F-7, and I believe F-7 is open for new
packages, so yes. I'll get that set up too, soon.
Comment 17 Stephen Warren 2007-11-18 14:40:19 EST
Package Change Request
======================
Package Name: fxload
New Branches: F-7
Comment 18 Kevin Fenzi 2007-11-18 14:42:25 EST
cvs done.
Comment 19 Stephen Warren 2007-11-18 14:54:41 EST
Nicolas: The F-7 build is done; just needs to be signed to get into testing.
Comment 20 Fedora Update System 2007-11-20 12:56:32 EST
fxload-2002_04_11-6.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update fxload'
Comment 21 Fedora Update System 2007-11-20 13:11:15 EST
fxload-2002_04_11-6.fc8 has been pushed to the Fedora 8 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update fxload'
Comment 22 Fedora Update System 2007-11-28 20:37:56 EST
fxload-2002_04_11-6.fc7 has been pushed to the Fedora 7 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 23 Fedora Update System 2007-11-28 20:46:47 EST
fxload-2002_04_11-6.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Stephen Warren 2008-02-09 02:58:36 EST
Package Change Request
======================
Package Name: fxload
New Branches: EL-5
Comment 25 Kevin Fenzi 2008-02-09 14:42:03 EST
cvs done.

Note You need to log in before you can comment on or make changes to this bug.